package com.rf.kjb.area.dao.model;

import com.rf.kjb.base.model.BaseEntry;
import lombok.*;
import org.hibernate.Hibernate;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Objects;

/**
 * @Author:zzf
 * @Date:2023/5/12:10:14
 * @Description:
 */
@Getter
@Setter
@ToString
@RequiredArgsConstructor
@Entity
@AllArgsConstructor
//@NoArgsConstructor
@Table(name = "t_province_info")
@org.hibernate.annotations.Table(appliesTo = "t_province_info", comment = "地区信息表")
@DynamicUpdate
public class ProvinceEntity extends BaseEntry {
    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o)) return false;
        ProvinceEntity that = (ProvinceEntity) o;
        return getId() != null && Objects.equals(getId(), that.getId());
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }
    @Column(name = "province_code",columnDefinition = "varchar(10) not null unique comment '编码'")
    private String provinceCode;
    @Column(name = "province_name",columnDefinition = "varchar(20) not null unique comment '名称'")
    private String provinceName;

}
