package com.rf.kjb.area.rest;

import com.alibaba.fastjson.JSONObject;
import com.rf.kjb.area.dao.model.ProvinceEntity;
import com.rf.kjb.area.service.ProvinceService;
import com.rf.kjb.base.rest.BaseController;
import com.rf.kjb.utils.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @Author:zzf
 * @Date:2023/5/12:10:30
 * @Description:
 */
@RestController
@RequestMapping("/v1/province")
@Slf4j
@Api(tags = "地区信息")
public class ProvinceController extends BaseController {

    @Autowired
    private ProvinceService service;

    @ApiOperation(value = "保存",notes = "provinceCode:编码；provinceName：名称")
    @PostMapping("/save")
    public Result save(@RequestBody String jsonObject){
        ProvinceEntity provinceEntity = JSONObject.toJavaObject(JSONObject.parseObject(jsonObject),ProvinceEntity.class);
        provinceEntity = this.service.save(provinceEntity);
        return success(provinceEntity);
    }


    @ApiOperation("全量查询")
    @GetMapping("/find")
    public Result find(){
        List<ProvinceEntity> provinceEntityList = this.service.findAll();
        return success(provinceEntityList);
    }
}
