package com.rf.kjb.base.rest;


import com.rf.kjb.exception.ErrorCode;
import com.rf.kjb.utils.Result;
import org.springframework.util.StringUtils;

/**
 * @author zzf
 * @description:
 * @date 2021/1/18 19:20
 */
public class BaseController {

    protected Result success() {
        return success(null, "成功");
    }

    protected static <T> Result<T> success(T data) {
        return success(data, "完成");
    }

    protected static <T> Result<T> success(T data, String message) {
        if (null == data) {
            return new Result<>(ErrorCode.SUCCESS.getErrorCode(), StringUtils.isEmpty(message)?ErrorCode.SUCCESS.getErrorMsg():message);
        }
        return new Result<>(ErrorCode.SUCCESS.getErrorCode(), StringUtils.isEmpty(message)?ErrorCode.SUCCESS.getErrorMsg():message, data);
    }

    protected static  Result fail(ErrorCode errorCode){
        return new Result<>(errorCode.getErrorCode(),errorCode.getErrorMsg());
    }




}
