package com.rf.kjb.chat.dao.domain;

import com.rf.kjb.base.model.BaseEntry;
import lombok.*;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Author:zzf
 * @Date:2022/10/21:00:30
 * @Description:
 */
@Entity
@Data
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_chat_answer")
@org.hibernate.annotations.Table(appliesTo = "t_chat_answer", comment = "对话答案表")
public class ChatAnswerEntity extends BaseEntry {

    @Column(name = "question_no",columnDefinition = "varchar(50) not null comment '问题编号'")
    private String questionNo;

    @Column(name = "next_question_no",columnDefinition = "varchar(50) not null comment '下一个问题编号'")
    private String nextQuestionNo;

    @Column(name = "question_type",columnDefinition = "varchar(2) not null comment '题目类型：0 选择题 1填空题 2跳转路由'")
    private String questionType;

    @Column(name = "answer",columnDefinition = "varchar(200) not null comment '答案信息'")
    private String answer;

    @Column(name = "label",columnDefinition = "varchar(2) not null comment '分类：1-焦虑；2-抑郁；3-失眠；4-压力；5-开场白'")
    private String label;
}
