package com.rf.kjb.chat.dao.domain;

import lombok.*;

import javax.persistence.*;

/**
 * @Author:zzf
 * @Date:2022/10/21:00:30
 * @Description:
 */
@Entity
@Data
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_chat_question")
@org.hibernate.annotations.Table(appliesTo = "t_chat_question", comment = "对话问题表")
@IdClass(ChatQuestionId.class)
public class ChatQuestionEntity   {
    @Id
    @Column(name = "id", columnDefinition = "varchar(36) COMMENT '数据ID'")
    private String id;
    @Column(name = "question",columnDefinition = "varchar(500) not null comment '问题'")
    private String question;

    @Column(name = "next_question_no",columnDefinition = "varchar(50) not null comment '下一个问题编号'")
    private String nextQuestionNo;

    @Column(name = "question_type",columnDefinition = "varchar(200) not null comment '题目类型：0 选择题 1填空题 2跳转路由'")
    private String questionType;

    @Id
    @Column(name = "label",columnDefinition = "varchar(2) not null comment '分类：1-焦虑；2-抑郁；3-失眠；4-压力；5-开场白'")
    private String label;

    @Column(name = "scale_flag",columnDefinition = "varchar(50) comment '量表标志，如果是量表的题目信息，此处为量表flag'")
    private String scaleFlag;
}
