package com.rf.kjb.chat.dao.domain;

import com.rf.kjb.base.model.BaseEntry;
import lombok.*;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Author:zzf
 * @Date:2023/9/14:15:19
 * @Description:
 */
@Entity
@Data
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_chat_record")
@org.hibernate.annotations.Table(appliesTo = "t_chat_record", comment = "对话记录表")
public class ChatRecordEntity extends BaseEntry {
    @Column(name = "user_name",columnDefinition = "varchar(50) not null comment '用户名'")
    private String userName;

    @Column(name = "identifier" ,columnDefinition = "varchar(20) not null  comment '编号'")
    private String identifier;

    @Column(name = "label",columnDefinition = "varchar(2) not null comment '分类：1-焦虑；2-抑郁；3-失眠；4-压力'")
    private String label;

    @Column(name = "content",columnDefinition = "text not null comment '对话内容'")
    private String content;

    @Column(name = "file_path",columnDefinition = "varchar(200) comment '文件路径'")
    private String filePath;
}
