package com.rf.kjb.chat.dao.domain;

import com.rf.kjb.base.model.BaseEntry;
import lombok.*;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Author:zzf
 * @Date:2023/9/6:10:58
 * @Description: 根据量表的测试结果查询下一问题编号
 */
@Entity
@Data
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "result_question")
@org.hibernate.annotations.Table(appliesTo = "result_question", comment = "根据量表的测试结果查询下一问题编号")
@DynamicUpdate
public class ResultQuestionEntity extends BaseEntry {
    @Column(name = "label",columnDefinition = "varchar(2) not null comment '分类：1-焦虑；2-抑郁；3-失眠；4-压力'")
    private String label;

    @Column(name = "result",columnDefinition = "varchar(50) not null comment '量表测试结果'")
    private String result;

    @Column(name = "next_question_no",columnDefinition = "varchar(50) not null comment '下一问题编号'")
    private String nextQuestionNo;
}
