package com.rf.kjb.chat.service.impl;

import com.rf.kjb.chat.dao.domain.ChatAnswerEntity;
import com.rf.kjb.chat.dao.repository.ChatAnswerRepository;
import com.rf.kjb.chat.service.ChatAnswerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Author:zzf
 * @Date:2022/10/21:01:06
 * @Description:
 */
@Service
public class ChatAnswerServiceImpl implements ChatAnswerService {

    @Autowired
    private ChatAnswerRepository answerRepository;
    @Override
    public List<ChatAnswerEntity> findByQuestionNo(String questionNo) {
        return this.answerRepository.findByQuestionNo(questionNo);
    }

    @Override
    public List<ChatAnswerEntity> findByQuestionNoAndLabel(String questionNo, String label) {
        return this.answerRepository.findByQuestionNoAndLabel(questionNo,label);
    }

    @Override
    public void deleteByLabel(String label) {
        this.answerRepository.deleteByLabel(label);
    }

    @Override
    public void saveBatch(List<ChatAnswerEntity> chatAnswerEntityList) {
        this.answerRepository.saveAll(chatAnswerEntityList);
    }
}
