package com.rf.kjb.excel;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zzf
 * @description:Excel导出辅助类，自定义表头和字段英文值
 * @date 2021/1/27 9:21
 */
public class ExcelClass {

    /**
     * 全量导出，自定义flag
     *
     * @param
     * @return
     */
    public Map<Integer, List<ExcelBean>> contentExcel() {
        List<ExcelBean> excel = new ArrayList<>();
        Map<Integer, List<ExcelBean>> map = new LinkedHashMap<>();
        //设置标题栏
        excel.add(new ExcelBean("题号", "questionNo", 0));
        excel.add(new ExcelBean("题目", "answer", 0));
        excel.add(new ExcelBean("选择项", "checkItems", 0));
        excel.add(new ExcelBean("类型", "questionType", 0));
        excel.add(new ExcelBean("计分方向", "scoreDirection", 0));
        map.put(0, excel);
        return map;
    }

    public Map<Integer, List<ExcelBean>> userExportExcel() {
        List<ExcelBean> excel = new ArrayList<>();
        Map<Integer, List<ExcelBean>> map = new LinkedHashMap<>();
        //设置标题栏
        excel.add(new ExcelBean("机构名称", "institutionName", 0));
        excel.add(new ExcelBean("机构编号", "institutionNo", 0));
        excel.add(new ExcelBean("姓名", "petName", 0));
        excel.add(new ExcelBean("性别", "gender", 0));
        excel.add(new ExcelBean("出生年月", "birthday", 0));
        excel.add(new ExcelBean("职业", "profession", 0));
        excel.add(new ExcelBean("附加信息", "additionInfo", 0));
        excel.add(new ExcelBean("账号", "phone", 0));
        excel.add(new ExcelBean("密码", "password", 0));
        map.put(0, excel);
        return map;
    }
            /*excel.add(new ExcelBean("任务","backCount",0));
            excel.add(new ExcelBean("组块","groupCount",0));
            excel.add(new ExcelBean("字符次序","charShowCount",0));
            excel.add(new ExcelBean("字符","charStr",0));
            excel.add(new ExcelBean("响应时长(毫秒)","time",0));*/

    /**
     * 自定义导出
     *
     * @param entryMap key:中文表头  value 英文字段，与实体类一一对应
     * @return
     */
    public Map<Integer, List<ExcelBean>> contentExcel(Map<String, String> entryMap) {
        List<ExcelBean> excel = new ArrayList<>();
        Map<Integer, List<ExcelBean>> map = new LinkedHashMap<>();
        //设置标题栏
        for (Map.Entry<String, String> entry : entryMap.entrySet()) {
            excel.add(new ExcelBean(entry.getValue(), entry.getKey(), 0));
            map.put(0, excel);
        }
        return map;
    }
}
