package com.rf.kjb.exception;

import lombok.Getter;

@Getter
public enum ErrorCode {
    /** 系统 **/
    SUCCESS(200,"处理完成"),
    FAILED(201,"失败"),

    /** 用户模块错误码 **/
    USER_EXISTS(1001,"用户已存在"),
    USER_NOT_EXISTS(1002,"用户不存在"),
    LOGIN_ERROR(1003, "账号或密码错误"),

    IDENTIFIER_NULL(1004,"用户编号为空"),
    PASSWORD_DIFF(1005, "两次输入的密码不一致"),
    ROLE_ERROR(1006,"用户角色有误"),
    OLD_PWD_ERROR(1007,"旧密码错误"),
    /** 量表 **/
    CATEGORY_EXIST(2001,"量表类别已存在"),
    SCALE_UNUSEFUL(2002,"量表不可用"),
    NEXT_QUESTION_NO_NOT_FOUND(2003,"未设置下一问题编号"),
    NEXT_QUESTION_NO_ERROR(2004,"下一问题编号设置错误"),
    CHAT_CONTENT_EMPTY(2005,"对话内容为空"),

    ;



    ErrorCode(int errorCode, String errorMsg) {
        this.errorCode = errorCode;
        this.errorMsg = errorMsg;
    }

    int errorCode;
    String errorMsg;
}
