package com.rf.kjb.filter;

import com.rf.kjb.utils.JWTUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.HandlerInterceptor;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author lpf
 * @description:
 * @date 2021/01/20 16:54
 */
@Slf4j
@Component
public class UserCheckInterceptor implements HandlerInterceptor {

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        //获取请求头token
        String token = request.getHeader("Authorization");
        token = token.split(" ")[1];//以空格划分Bearer token，获取token
        JWTUtil.verify(token);//验证令牌

        return true; //放行
    }
}
