package com.rf.kjb.hospital.dao.model;

import com.rf.kjb.base.model.BaseEntry;
import lombok.*;
import org.hibernate.Hibernate;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Objects;

/**
 * @Author:zzf
 * @Date:2023/5/12:10:56
 * @Description:
 */
@Getter
@Setter
@ToString
@RequiredArgsConstructor
@Entity
@AllArgsConstructor
//@NoArgsConstructor
@Table(name = "t_hospital_info")
@org.hibernate.annotations.Table(appliesTo = "t_hospital_info", comment = "医院信息表")
@DynamicUpdate
public class HospitalEntity extends BaseEntry {
    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || Hibernate.getClass(this) != Hibernate.getClass(o)) return false;
        HospitalEntity that = (HospitalEntity) o;
        return getId() != null && Objects.equals(getId(), that.getId());
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }

    @Column(name = "province_code",columnDefinition = "varchar(10) not null comment '地区编码'")
    private String provinceCode;

    @Column(name = "hospital_name",columnDefinition = "varchar(50) not null comment '医院名称'")
    private String hospitalName;

    @Column(name = "address",columnDefinition = "varchar(200) not null comment '地址'")
    private String address;

    @Column(name = "section",columnDefinition = "varchar(20) not null comment '科室'")
    private String section;

    @Column(name = "contact_number",columnDefinition = "varchar(255) not null comment '联系电话'")
    private String contactNumber;

}
