package com.rf.kjb.hospital.rest;

import com.alibaba.fastjson.JSONObject;
import com.rf.kjb.area.dao.model.ProvinceEntity;
import com.rf.kjb.area.service.ProvinceService;
import com.rf.kjb.base.rest.BaseController;
import com.rf.kjb.hospital.dao.model.HospitalEntity;
import com.rf.kjb.hospital.service.HospitalService;
import com.rf.kjb.utils.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @Author:zzf
 * @Date:2023/5/12:11:27
 * @Description:
 */
@RestController
@RequestMapping("/v1/hospital")
@Slf4j
@Api(tags = "医院信息")
public class HospitalController extends BaseController {
    @Autowired
    private HospitalService service;

    @ApiOperation(value = "保存",notes = "provinceCode:地区编码；hospitalName：名称；address：地址；section：科室；contactNumber：联系电话")
    @PostMapping("/save")
    public Result save(@RequestBody String json){
        HospitalEntity hospitalEntity = JSONObject.toJavaObject(JSONObject.parseObject(json),HospitalEntity.class);
        hospitalEntity = this.service.save(hospitalEntity);
        return success(hospitalEntity);
    }


    @ApiOperation(value = "全量查询",notes = "id:数据库主键；provinceCode：地区编码；hospitalName：名称；address:地址 pageNum：可为空，默认1 ；pageSize：可为空，默认10")
    @PostMapping("/find")
    public Result find(@RequestBody String json){
        JSONObject jsonObject = JSONObject.parseObject(json);
        Page<HospitalEntity> provinceEntityList = this.service.findAll(jsonObject);
        return success(provinceEntityList);
    }
}
