package com.rf.kjb.intelligentDialogue.dao.repository;

import com.rf.kjb.base.repository.BaseRepository;
import com.rf.kjb.intelligentDialogue.dao.domain.IntelligentDialogueEntity;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface IntelligentDialogueRepository extends BaseRepository<IntelligentDialogueEntity,String> {

    /*@Query(value = "SELECT t1.* FROM t_chat_record t1 INNER JOIN (SELECT MAX(create_time) AS create_time FROM t_chat_record GROUP BY identifier ) t2 ON t1.create_time = t2.create_time " +
            "where 1=1 and ( if(:searchKey is not null and :searchKey!='',t1.identifier like CONCAT('%',:searchKey,'%')  ,1=1) " +
            "or if(:searchKey is not null and :searchKey!='',t1.user_name like CONCAT('%',:searchKey,'%')  ,1=1)) and " +
            "if(:beginTime is not null and :beginTime!='',t1.create_time>:beginTime ,1=1)  and if(:endTime is not null and :endTime!='', t1.create_time<:endTime ,1=1)" +
            "limit :pageNum ,:pageSize ", nativeQuery = true)*/
    @Query(value = "SELECT t1.* FROM t_intelligent_dialogue t1 INNER JOIN (SELECT MAX(id) AS id FROM t_intelligent_dialogue GROUP BY identifier ) t2 ON t1.id = t2.id " +
            "where 1=1 and ( if(:searchKey is not null and :searchKey!='',t1.identifier like CONCAT('%',:searchKey,'%')  ,1=1) " +
            "or if(:searchKey is not null and :searchKey!='',t1.user_name like CONCAT('%',:searchKey,'%')  ,1=1)) ",
            countQuery = "SELECT t1.* FROM t_intelligent_dialogue t1 INNER JOIN (SELECT MAX(id) AS id FROM t_intelligent_dialogue GROUP BY identifier ) t2 ON t1.id = t2.id " +
                    "where 1=1 and ( if(:searchKey is not null and :searchKey!='',t1.identifier like CONCAT('%',:searchKey,'%')  ,1=1) " +
                    "or if(:searchKey is not null and :searchKey!='',t1.user_name like CONCAT('%',:searchKey,'%')  ,1=1)) ", nativeQuery = true)
    Page<IntelligentDialogueEntity> getIntelligentDialogueList(Pageable pageable, @Param("searchKey") String searchKey);

    List<IntelligentDialogueEntity> findByIdentifier(String identifier);

    @Query(value = "SELECT t1.* FROM t_intelligent_dialogue t1 INNER JOIN (SELECT MAX(id) AS id FROM t_intelligent_dialogue GROUP BY identifier ) t2 ON t1.id = t2.id ", nativeQuery = true)
    List<IntelligentDialogueEntity> findAllIdentifier();

    @Query(value = "SELECT * FROM t_intelligent_dialogue WHERE identifier = :identifier ORDER BY create_time DESC ",
            countQuery = "SELECT * FROM t_intelligent_dialogue WHERE identifier = :identifier ", nativeQuery = true)
    Page<IntelligentDialogueEntity> getIntelligentDialogueEntityByIdentifier(Pageable pageable, @Param("identifier") String identifier);
}
