package com.rf.kjb.intelligentDialogue.service.impl;

import com.rf.kjb.intelligentDialogue.dao.domain.IntelligentDialogueEntity;
import com.rf.kjb.intelligentDialogue.dao.repository.IntelligentDialogueRepository;
import com.rf.kjb.intelligentDialogue.service.IntelligentDialogueService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Author:zzf
 * @Date:2023/9/14:15:27
 * @Description:
 */
@Service
public class IntelligentDialogueServiceImpl implements IntelligentDialogueService {
    @Autowired
    private IntelligentDialogueRepository repository;
    @Override
    public void save(IntelligentDialogueEntity intelligentDialogue) {
        repository.save(intelligentDialogue);
    }

    @Override
    public Page<IntelligentDialogueEntity> find(String searchKey, int pageNum, int pageSize) {
        return this.repository.getIntelligentDialogueList(PageRequest.of(pageNum - 1, pageSize), searchKey);
        /*Specification<IntelligentDialogueEntity> specification = (root, query, cb) -> {
            List<javax.persistence.criteria.Predicate> predicateList = new ArrayList<>();
            if(StringUtils.isNotBlank(identifier)){
                predicateList.add(cb.or(cb.like(root.get("identifier"),"%"+identifier+"%"),cb.like(root.get("userName"),"%"+identifier+"%")));
            }
            try {
                if(StringUtils.isNotBlank(beginDate)){
                    predicateList.add(cb.greaterThanOrEqualTo(root.get("createTime"),new SimpleDateFormat("yyyy-MM-dd").parse(beginDate)));
                }

                if(StringUtils.isNotBlank(endDate)){
                    predicateList.add(cb.lessThanOrEqualTo(root.get("createTime"),new SimpleDateFormat("yyyy-MM-dd").parse(endDate)));
                }
            } catch (ParseException e) {
                throw new RuntimeException(e);
            }
            query.where(cb.and(predicateList.toArray(new Predicate[0])));
            query.orderBy(cb.asc(root.get("createTime")));
            return query.getRestriction();
        };
        if (pageNum <= 0) {
            pageNum = 1;
        }
        if(pageSize <= 0){
            pageSize = 10;
        }
        return this.repository.findAll(specification, PageRequest.of(pageNum-1,pageSize));*/
    }

    @Override
    public List<IntelligentDialogueEntity> findByIdentifier(String identifier) {
        return this.repository.findByIdentifier(identifier);
    }

    @Override
    public List<IntelligentDialogueEntity> findAllIdentifier() {
        return this.repository.findAllIdentifier();
    }

    @Override
    public Page<IntelligentDialogueEntity> getIntelligentDialogueEntityByIdentifier(String identifier, int pageNum, int pageSize) {
        return this.repository.getIntelligentDialogueEntityByIdentifier(PageRequest.of(pageNum - 1, pageSize), identifier);
    }
}
