package com.rf.kjb.scale.dao.model;

import com.rf.kjb.base.model.BaseEntry;
import lombok.*;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;

/**
 * @author zsy
 * @description:量表类别信息表
 * @date 2021/6/17 15:55
 */
@Entity
@Data
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_category_info",indexes = {
        @Index(columnList = "ename"),
        @Index(columnList = "type")
})
@org.hibernate.annotations.Table(appliesTo = "t_category_info", comment = "量表类别信息表")
public class CategoryEntry extends BaseEntry {

    @Column(name = "name", columnDefinition = "varchar(10) not null comment '类别名称(唯一)'")
    private String name;

    @Column(name = "ename", columnDefinition = "varchar(10) not null comment '英文名称(唯一)'")
    private String ename;

    @Column(name = "sequence", columnDefinition = "int(5) not null comment '排序(唯一)'")
    private String sequence;

    @Column(name = "type", columnDefinition = "varchar(10) not null comment '类型：0-量表；1-认知任务'")
    private String type;

}
