package com.rf.kjb.scale.dao.model;

import com.rf.kjb.base.model.BaseEntry;
import lombok.*;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;

/**
 * @author zsy
 * @description:量表-类别关联表
 * @date 2021/6/17 15:55
 */
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_category_subject" ,indexes ={
        @Index(columnList = "flag"),
        @Index(columnList = "ename")
})
@org.hibernate.annotations.Table(appliesTo = "t_category_subject", comment = "量表-类别关联表")
public class CategorySubjectEntity extends BaseEntry {

    @Column(name="flag" ,columnDefinition = "varchar(50) not null comment '量表查询标志'")
    private String flag ;

    @Column(name = "ename",columnDefinition = "varchar(10) not null comment '类别英文名称'")
    private String ename;

}
