package com.rf.kjb.scale.dao.model;

import com.rf.kjb.base.model.BaseEntry;
import lombok.*;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Author:zzf
 * @Date:2023/6/7:09:55
 * @Description:
 */
@Entity
@Data
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_game_record_info")
@org.hibernate.annotations.Table(appliesTo = "t_game_record_info", comment = "游戏记录")
@DynamicUpdate
public class GameRecordEntity extends BaseEntry {

    @Column(name = "identifier" ,columnDefinition = "varchar(20) not null  comment '编号'")
    private String identifier;

    @Column(name = "game_scene",columnDefinition = "varchar(255) not null comment '游戏场景'")
    private String gameScene;

    @Column(name = "equipment_type",columnDefinition = "varchar(10) not null comment '设备类型'")
    private String equipmentType;

    @Column(name = "game_difficulty",columnDefinition = "varchar(20) not null comment '游戏难度'")
    private String  gameDifficulty;

    @Column(name = "game_time",columnDefinition = "varchar(20) not null comment '游戏时间'")
    private String gameTime;

    @Column(name = "animation_source_list",columnDefinition = "text not null comment '原始数据'")
    private String animationSourceList;

    @Column(name = "animation_target",columnDefinition = "text not null comment '指标数据'")
    private String animationTarget;

    @Column(name = "save_time",columnDefinition = "varchar(50) not null comment '保存指标时间'")
    private String saveTime;

    @Column(name = "file_name",columnDefinition = "varchar(100) not null comment '文件名'")
    private String fileName;
}
