package com.rf.kjb.scale.dao.model;

import com.rf.kjb.base.model.BaseEntry;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @author zsy
 * @description:用户测试记录信息表
 * @date 2021/6/17 15:55
 */
@Entity
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_user_record")
@org.hibernate.annotations.Table(appliesTo = "t_user_record", comment = "用户测试记录信息表")
public class RecordEntity extends BaseEntry {

    @Column(name = "identifier", columnDefinition = "varchar(11) not null comment '用户手机号（登录账号）'")
    private String identifier;

    @Column(name = "flag", columnDefinition = "varchar(50) comment '量表/认知任务/生理标志'")
    private String flag;

    @Column(name = "test_date", columnDefinition = "varchar(50) not null comment '测试日期'")
    private String testDate;

    @Column(name = "test_result", columnDefinition = "text comment '测试结果'")
    private String testResult;

    @Column(name = "test_results", columnDefinition = "text comment '测试结果(String类型)'")
    private String testResults;

    @Column(name = "file_name", columnDefinition = "varchar(255) comment '测试结果文件名称'")
    private String fileName;

    @Column(name = "img", columnDefinition = "text comment 'b64格式图片'")
    private String img;

    @Column(name = "test_record", columnDefinition = "text comment '答题记录'")
    private String testRecord;

}
