package com.rf.kjb.scale.dao.model;

import com.rf.kjb.base.model.BaseEntry;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Author:zzf
 * @Date:2022/7/28:19:01
 * @Description:生理测试结果
 */
@Entity
@Data
@EqualsAndHashCode(callSuper=true)
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_user_record_phy")
@org.hibernate.annotations.Table(appliesTo = "t_user_record_phy", comment = "生理测试记录")
@DynamicUpdate
public class RecordPhyEntry extends BaseEntry {

    @Column(name = "test_date", columnDefinition = "varchar(50) not null comment '测试日期'")
    private String testDate;

    @Column(name = "test_result", columnDefinition = "mediumtext comment '测试结果'")
    private String testResult;

    @Column(name = "source_data",columnDefinition = "text comment '原始数据'")
    private String sourceData;

    @Column(name = "type", columnDefinition = "varchar(2) comment '类型：1为脉搏；2为心电；3为脑电'")
    private String type;

    @Column(name = "file_name",columnDefinition = "varchar(255) comment '文件名称'")
    private String fileName;

    @Column(name = "identifier",columnDefinition = "varchar(20) comment '用户编号'")
    private String identifier;

    @Column(name = "target",columnDefinition = "text comment '指标数据'")
    private String target;
}
