package com.rf.kjb.scale.dao.repository;

import com.rf.kjb.base.repository.BaseRepository;
import com.rf.kjb.scale.dao.model.RecordPhyEntry;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface RecordPhyRepository extends BaseRepository<RecordPhyEntry,String> {

    /**
     * 删选identifier
     * @param identifiers
     * @param type
     * @param startDate
     * @param endDate
     * @param i
     * @param pageSize
     * @return
     */

    @Query(value = "select distinct identifier from t_user_record_phy t where 1 = 1" +
            " and if ( :type is not null and :type != '',t.type = :type ,1=1) " +
            " and if (:startDate is not null and :startDate != '',t.test_date >= :startDate,1=1)" +
            " and if (:endDate is not null and :endDate != '',t.test_date <= :endDate,1=1)" +
            " and if (:userName is not null and :userName != '',t.identifier in (select identifier from t_user_info where user_name like :userName),1=1)" +
            " limit :pageNum,:pageSize",nativeQuery = true)
    List<String> findIdentifiers(@Param("type") String type, @Param("startDate") String startDate,@Param("userName") String userName, @Param("endDate") String endDate,@Param("pageNum") int pageNum,@Param("pageSize") int pageSize);

    @Query(value = "select count(distinct identifier) from t_user_record_phy t where 1 = 1" +
            " and if ( :type is not null and :type != '',t.type = :type ,1=1) " +
            " and if (:startDate is not null and :startDate != '',t.test_date >= :startDate,1=1)" +
            " and if (:endDate is not null and :endDate != '',t.test_date <= :endDate,1=1)" +
            " and if (:userName is not null and :userName != '',t.identifier in (select identifier from t_user_info where user_name like :userName),1=1)" +
            "",nativeQuery = true)
    int findIdentifiersCount(@Param("type") String type, @Param("startDate") String startDate,@Param("userName") String userName, @Param("endDate") String endDate);

    List<RecordPhyEntry> findByType(String type);

    void deleteByIdentifier(String identifier);


//    List<String> findIdentifiers(@Param("type") String type,@Param("userName") String userName,@Param("pageNum") int pageNum,@Param("pageSize") int pageSize);
}
