package com.rf.kjb.scale.dao.repository;

import com.rf.kjb.base.repository.BaseRepository;
import com.rf.kjb.scale.dao.model.RecordEntity;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @author zsy
 * @description:用户测试记录
 * @date 2021/6/17 15:55
 */
public interface RecordRepository extends BaseRepository<RecordEntity, String> {


    /**
     * 根据id查询数据
     *
     * @return
     */
    @Query(value = "select * from t_user_record where id = :id ", nativeQuery = true)
    RecordEntity getUserRecordById(@Param("id") String id);


    @Query(value = "select distinct identifier from t_user_record t where 1 = 1" +
            " and if (:startDate is not null and :startDate != '',t.test_date >= :startDate,1=1)" +
            " and if (:endDate is not null and :endDate != '',t.test_date <= :endDate,1=1)" +
            " and if (:flag is not null and :flag != '',t.flag = flag,1=1)" +
            " and if (:userName is not null and :userName != '',t.identifier in (select identifier from t_user_info where user_name like :userName),1=1)" +
            " limit :pageNum,:pageSize",nativeQuery = true)
    List<String> findIdentifiers(@Param("flag") String flag ,@Param("startDate") String startDate, @Param("userName") String userName, @Param("endDate") String endDate, @Param("pageNum") int pageNum, @Param("pageSize") int pageSize);

    @Query(value = "select count(distinct identifier) from t_user_record t where 1 = 1" +
            " and if (:startDate is not null and :startDate != '',t.test_date >= :startDate,1=1)" +
            " and if (:endDate is not null and :endDate != '',t.test_date <= :endDate,1=1)" +
            " and if (:flag is not null and :flag != '',t.flag = flag,1=1)" +
            " and if (:userName is not null and :userName != '',t.identifier in (select identifier from t_user_info where user_name like :userName),1=1)" +
            "",nativeQuery = true)
    int findIdentifiersCount(@Param("flag") String flag, @Param("startDate") String startDate,@Param("userName") String userName, @Param("endDate") String endDate);

    void deleteByIdentifier(String identifier);
}
