package com.rf.kjb.scale.dao.repository;

import com.rf.kjb.base.repository.BaseRepository;
import com.rf.kjb.scale.dao.model.ScaleEntry;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author zzf
 * @description:
 * @date 2021/5/14 10:54
 */
public interface ScaleRepository extends BaseRepository<ScaleEntry,String> {

    /**
     * 根据flag查询检测列表
     * @param flag
     * @return
     */
    @Query(value="select * from t_scale_info where flag = :flag order by question_no+0,serial_no+0 ",nativeQuery=true)
    List<ScaleEntry> getScaleByFlag(@Param("flag")String flag);

    @Transactional
    @Modifying(clearAutomatically = true)
    @Query(value = "delete from t_scale_info", nativeQuery = true)
    void deleteAll();

    /**
     * 根据id修改指定字段
     *
     * @return
     */
    @Transactional
    @Modifying(clearAutomatically = true)
    @Query(value = "UPDATE t_scale_info SET content = :answer, check_item = :checkItems WHERE id = :id ", nativeQuery = true)
    void updateScale(@Param("answer")String answer, @Param("checkItems")String checkItems, @Param("id")String id);

}
