package com.rf.kjb.scale.rest;

import com.alibaba.fastjson.JSONObject;
import com.rf.kjb.base.rest.BaseController;
import com.rf.kjb.scale.dao.model.GameRecordEntity;
import com.rf.kjb.scale.service.GameRecordService;
import com.rf.kjb.utils.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.*;

/**
 * @Author:zzf
 * @Date:2023/6/7:09:55
 * @Description:游戏记录
 */
@Slf4j
@RestController
@RequestMapping("/v1/game/record")
@Api(tags = "游戏记录")
public class GameRecordController extends BaseController {
    @Autowired
    private GameRecordService gameRecordService;
    @ApiOperation(value = "保存记录")
    @PostMapping("/save")
    public Result save(@RequestBody String json){
        GameRecordEntity gameRecordEntity = JSONObject.parseObject(json).toJavaObject(GameRecordEntity.class);
        this.gameRecordService.save(gameRecordEntity);
        return success();
    }

    @ApiOperation(value = "查询",notes = "id:游戏记录id；identifier：编号；gameScene：游戏场景；equipmentType：设备类型；gameDifficulty：游戏难度；gameTime：游戏时间；fileName：文件名;pageNum:页数，默认1；pageSize：每页记录数，默认10")
    @GetMapping("/find")
    public Result find(@RequestBody String json){
        Page<GameRecordEntity> page = this.gameRecordService.find(json);
        return success(page);
    }
}
