package com.rf.kjb.scale.rest;

import com.rf.kjb.base.rest.BaseController;
import com.rf.kjb.scale.dao.model.ScaleEntry;
import com.rf.kjb.scale.dao.model.SubjectEntity;
import com.rf.kjb.scale.service.ScaleService;
import com.rf.kjb.scale.service.SubjectService;
import com.rf.kjb.utils.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @Author:zzf
 * @Date:2022/7/28:17:03
 * @Description:
 */
@RestController
@RequestMapping("/v1/scale")
@Api(tags = "量表")
public class SubjectController extends BaseController {

    @Autowired
    private SubjectService subjectService;

    @Autowired
    private ScaleService scaleService;

    @PostMapping("/find")
    @ApiOperation(value = "查询量表",notes = "pageNum 页数，默认值1  pageSize 每页记录数，默认值10 name 量表名称(可为空)  flag 量表标志(可为空) typeName:分类英文名(可为空) role 用户角色")
    public Result find(@RequestBody String json){
        Page<SubjectEntity> list = this.subjectService.find(json);
        return success(list);
    }

    /**
     * 题目查询
     * @param flag
     * @return
     */
    @GetMapping("/{flag}")
    @ApiOperation(value = "题目查询",notes = "flag 量表标志")
    public Result findScale(@PathVariable String flag){
        List<ScaleEntry> list = this.scaleService.getScaleByFlag(flag);
        return success(list);
    }

}
