package com.rf.kjb.scale.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.kjb.scale.dao.dto.NewResultDto;
import com.rf.kjb.scale.dao.model.*;
import com.rf.kjb.scale.util.ScaleConstant;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @author zsy
 * @description:职业性格测试
 * @date 2021/7/20 15:55
 */
public class MBTIScaleNEW extends BaseScale {

    public MBTIScaleNEW(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public JSONObject scaleCalculate() throws Exception {

        //总分
        double score = 0;
        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String, String>> resultMapList = new ArrayList<>();

        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取题目和答案列表
        List<ScaleEntry> scaleEntities = (List<ScaleEntry>) resultJson.get("scaleEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        if (dimensionEntities.size() > 0) {
            //计算每个维度得分
            double[] dimensionScore = new double[dimensionEntities.size()];
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject1 = jsonArray.getJSONObject(i);
                for (int y = 0; y < dimensionEntities.size(); y++) {
                    //for (DimensionEntity dimensionEntity:dimensionEntities){
                    DimensionEntity dimensionEntity = dimensionEntities.get(y);
                    String questionNos = dimensionEntity.getQuestionNo();
                    String[] questionNo = questionNos.split("；");
                    for (String question : questionNo) {
                        if (question.equals(jsonObject1.getString("questionNo"))) {
                            for (AnswerEntity answerEntity : answerEntities) {
                                if (answerEntity.getQuestionNo().equals(question) && answerEntity.getName().equals(jsonObject1.getString("checkItems"))) {
                                    String checkItems = scaleEntities.get(Integer.valueOf(answerEntity.getQuestionNo()) - 1).getCheckItems();
                                    String[] CheckIteml = checkItems.split("；");
                                    if ((y & 1) == 1) {
                                        if (CheckIteml[0].equals(jsonObject1.getString("checkItems"))) {
                                            dimensionScore[y] += Double.valueOf(answerEntity.getScore());
                                        } else {
                                            dimensionScore[y - 1] += Double.valueOf(answerEntity.getScore());
                                        }
                                    } else {
                                        if (CheckIteml[0].equals(jsonObject1.getString("checkItems"))) {
                                            dimensionScore[y] += Double.valueOf(answerEntity.getScore());
                                        } else {
                                            dimensionScore[y + 1] += Double.valueOf(answerEntity.getScore());
                                        }
                                    }
                                }
                            }
                            break;
                        }
                    }
                }
            }

            /*score = dimensionScore[0]+dimensionScore[1]+dimensionScore[2]+dimensionScore[3]+dimensionScore[5]-dimensionScore[4]-dimensionScore[6]+100;
            resultMap0.put("TMD(情绪纷乱的总分)", String.valueOf(score));
            resultJson.put("TMD(情绪纷乱的总分)", String.valueOf(score));*/
            for (int y = 0; y < dimensionEntities.size(); y += 2) {
                DimensionEntity dimensionEntity = dimensionEntities.get(y);
                DecimalFormat df = new DecimalFormat("######0.00");
                resultMap0.put(dimensionEntity.getName() + "得分", String.valueOf(Double.parseDouble(df.format(dimensionScore[y]))));
                resultJson.put(dimensionEntity.getName() + "得分", String.valueOf(Double.parseDouble(df.format(dimensionScore[y]))));
                resultMap0.put(dimensionEntities.get(y + 1).getName() + "得分", String.valueOf(Double.parseDouble(df.format(dimensionScore[y + 1]))));
                resultJson.put(dimensionEntities.get(y + 1).getName() + "得分", String.valueOf(Double.parseDouble(df.format(dimensionScore[y + 1]))));
            }
            resultMapList.add(resultMap0);
        }

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);
        //returnJson.put("scaleName",resultJson.getString("scaleName"));
        returnJson.put("resultJson", resultJson);

        return returnJson;
    }

    public JSONObject scaleCalculateV2() throws Exception {

        //总分
        double score = 0;
        //外倾(E)得分
        int scoreE = 0;
        //内倾(I)得分
        int scoreI = 0;
        //直觉(N)得分
        int scoreN = 0;
        //感觉(S)得分
        int scoreS = 0;
        //情感(F)得分
        int scoreF = 0;
        //思维(T)得分
        int scoreT = 0;
        //判断(J)得分
        int scoreJ = 0;
        //知觉(P)得分
        int scoreP = 0;
        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String, String>> resultMapList = new ArrayList<>();

        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取题目和答案列表
        List<ScaleEntry> scaleEntities = (List<ScaleEntry>) resultJson.get("scaleEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        //新版本数据格式
        Map<String, Object> newResult = null;
        if (dimensionEntities.size() > 0) {
            //计算每个维度得分
            double[] dimensionScore = new double[dimensionEntities.size()];
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject1 = jsonArray.getJSONObject(i);
                for (int y = 0; y < dimensionEntities.size(); y++) {
                    //for (DimensionEntity dimensionEntity:dimensionEntities){
                    DimensionEntity dimensionEntity = dimensionEntities.get(y);
                    String questionNos = dimensionEntity.getQuestionNo();
                    String[] questionNo = questionNos.split("；");
                    for (String question : questionNo) {
                        if (question.equals(jsonObject1.getString("questionNo"))) {
                            for (AnswerEntity answerEntity : answerEntities) {
                                if (answerEntity.getQuestionNo().equals(question) && answerEntity.getName().equals(jsonObject1.getString("checkItems"))) {
                                    if (dimensionEntity.getName().equals("外倾-内倾")){
                                        if (answerEntity.getOptions().equals("A")){
                                            scoreE += Double.parseDouble(answerEntity.getScore());
                                        }else {
                                            scoreI += Double.parseDouble(answerEntity.getScore());
                                        }
                                    }else if (dimensionEntity.getName().equals("感觉-直觉")){
                                        if (answerEntity.getOptions().equals("A")){
                                            scoreS += Double.parseDouble(answerEntity.getScore());
                                        }else {
                                            scoreN += Double.parseDouble(answerEntity.getScore());
                                        }
                                    }else if (dimensionEntity.getName().equals("思维-情感")){
                                        if (answerEntity.getOptions().equals("A")){
                                            scoreT += Double.parseDouble(answerEntity.getScore());
                                        }else {
                                            scoreF += Double.parseDouble(answerEntity.getScore());
                                        }
                                    }else {
                                        if (answerEntity.getOptions().equals("A")){
                                            scoreJ += Double.parseDouble(answerEntity.getScore());
                                        }else {
                                            scoreP += Double.parseDouble(answerEntity.getScore());
                                        }
                                    }
                                    String checkItems = scaleEntities.get(Integer.parseInt(answerEntity.getQuestionNo()) - 1).getCheckItems();
                                    String[] CheckIteml = checkItems.split("；");
                                    if ((y & 1) == 1) {
                                        if (CheckIteml[0].equals(jsonObject1.getString("checkItems"))) {
                                            dimensionScore[y] += Double.parseDouble(answerEntity.getScore());
                                        } else {
                                            dimensionScore[y - 1] += Double.parseDouble(answerEntity.getScore());
                                        }
                                    } else {
                                        if (CheckIteml[0].equals(jsonObject1.getString("checkItems"))) {
                                            dimensionScore[y] += Double.parseDouble(answerEntity.getScore());
                                        } else {
                                            dimensionScore[y + 1] += Double.parseDouble(answerEntity.getScore());
                                        }
                                    }
                                }
                            }
                            break;
                        }
                    }
                }
            }
            dimensionScore[0] = scoreE - scoreI;
            dimensionScore[1] = scoreS - scoreN;
            dimensionScore[2] = scoreT - scoreF;
            dimensionScore[3] = scoreJ - scoreP;


            //将量表总维度根据维度名称进行分组
            Map<String, List<ScaleMarksEntity>> scaleMarksMap = scaleMarksEntities.stream().collect(Collectors.groupingBy(ScaleMarksEntity::getName));
            newResult = new LinkedHashMap<>();
            //返回值以及存数据库格式
            List<NewResultDto> newResultDtos = new ArrayList<>();
            JSONObject iconInfo = new JSONObject();
            //雷达图需要的维度以及最大值
            List<Map<String, Object>> indicator = new LinkedList<>();
            //雷达图所需要的常模参考值
            LinkedList<String> reference = new LinkedList<>();
            //雷达图需要的分数
            LinkedList<String> scoreList = new LinkedList<>();
            NEWCOMMONScale.commonComputeDimensionScore(null, resultMap0, resultJson, "外倾-内倾", dimensionScore[0], true, scaleMarksMap, newResultDtos, indicator, reference, scoreList);
            NEWCOMMONScale.commonComputeDimensionScore(null, resultMap0, resultJson, "感觉-直觉", dimensionScore[1], true, scaleMarksMap, newResultDtos, indicator, reference, scoreList);
            NEWCOMMONScale.commonComputeDimensionScore(null, resultMap0, resultJson, "思维-情感", dimensionScore[2], true, scaleMarksMap, newResultDtos, indicator, reference, scoreList);
            NEWCOMMONScale.commonComputeDimensionScore(null, resultMap0, resultJson, "判断-知觉", dimensionScore[3], true, scaleMarksMap, newResultDtos, indicator, reference, scoreList);

            //需要图表展示的
            iconInfo.put("indicator", indicator);
            //判断是否有常模参考值，即reference的内容如果全为0，则不进行返回
            if (!reference.stream().allMatch("0"::equals)) {
                iconInfo.put("reference", reference);
            }
            iconInfo.put("scoreList", scoreList);
            if (indicator.size() == 0 && reference.size() == 0) {
                newResult.put("iconInfo", "");
            } else {
                newResult.put("iconInfo", iconInfo);
            }
            newResult.put("result", newResultDtos);
            resultMapList.add(resultMap0);
        }

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList", resultMapList);

        returnJson.put("resultJson", resultJson);
        returnJson.put(ScaleConstant.ResultEnum.RESULT_NEW_FIELD.getKeyword(), newResult);


        return returnJson;
    }
}
