package com.rf.kjb.scale.service;

import com.rf.kjb.scale.dao.model.RecordEntity;
import org.springframework.data.domain.Page;

import java.util.List;

/**
 * @author zsy
 * @description:用户测试记录
 * @date 2021/6/17 15:55
 */
public interface RecordService {

    /**
     * 保存
     *
     * @param userRecordEntity
     */
    RecordEntity save(RecordEntity userRecordEntity);

    /**
     * 根据id查询数据
     *
     * @return
     */
    RecordEntity getUserRecordById(String id);




    /**
     * 查询全量数据
     *
     * @return
     */
    List<RecordEntity> findAll();


    /**
     *
     * @param json
     * @return
     */
    List<String> findIdentifiers(String json);

    int findIdentifiersCount(String json);

    Page<RecordEntity> find(String json);

    RecordEntity findById(String id);

    /**
     * 不分页查询
     * @param json
     * @return
     */
    List<RecordEntity> findNoPage(String json);

    void deleteByIdentifier(String identifier);
}
