package com.rf.kjb.scale.service;

import com.rf.kjb.scale.dao.model.SubjectEntity;
import org.springframework.data.domain.Page;
import java.util.List;
import java.util.Optional;

/**
 * @author zzf
 * @description:
 * @date 2021/5/17 9:44
 */
public interface SubjectService {
    /**
     * 获取量表和认知任务列表
     *
     * @return
     */
    List<SubjectEntity> findAll(int pageNum, int pageSize);

    /**
     * 检索，根据中文名或录入人
     *
     * @param pageNum
     * @param pageSize
     * @param searchName
     * @return
     */
    List<SubjectEntity> findByNameOrUploader(int pageNum, int pageSize, String searchName);




    /**
     * 保存
     *
     * @param subjectEntity
     */
    void save(SubjectEntity subjectEntity);




    /**
     * 查询
     *
     * @param type 0：量表  1：认知任务
     * @return
     */
    List<SubjectEntity> findAll(String type);

    /**
     * 根据flag查询
     *
     * @return
     */
    SubjectEntity getSubjectByFlag(String flag);

    /**
     * 根据flag记录测试数
     *
     * @return
     */
    void addTestNum(String flag);






    /**
     * 修改量表测试结果效验状态
     *
     * @param flag
     * @return
     */
    void updateScaleStatus(String flag, String status);


    void update(SubjectEntity subjectEntity);

    Page<SubjectEntity> find(String json);
}
