package com.rf.kjb.scale.service.impl;

import com.rf.kjb.scale.dao.model.DimensionEntity;
import com.rf.kjb.scale.dao.repository.DimensionRepository;
import com.rf.kjb.scale.service.DimensionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.List;

/**
 * @author zsy
 * @description:
 * @date 2021/5/14 10:51
 */
@Service
@Slf4j
public class DimensionServiceImpl implements DimensionService {
    @Autowired
    private DimensionRepository dimensionRepository;

    /**
     * 保存
     *
     * @param dimensionEntity
     */
    @Override
    public void saveDimension(DimensionEntity dimensionEntity) {
        //dimensionEntity.encrypt();
        this.dimensionRepository.save(dimensionEntity);
    }

    @Override
    public void saveBatch(List<DimensionEntity> dimensionEntitys) {
        this.dimensionRepository.saveAll(dimensionEntitys);
    }

    /**
     * 根据flag查询维度信息
     *
     * @param flag
     */
    @Override
    public List<DimensionEntity> getDimensionByFlag(String flag) {
        return this.dimensionRepository.getDimensionByFlag(flag);
    }

    @Override
    public List<DimensionEntity> findAll() {
        return dimensionRepository.findAll();
    }

    @Override
    public void updateDimension(DimensionEntity dimensionEntity) {
        this.dimensionRepository.updateDimension(dimensionEntity.getName(),dimensionEntity.getQuestionNo(),dimensionEntity.getId());
    }

    @Override
    public void deleteDimensionByFlag(String flag) {
        this.dimensionRepository.deleteDimensionByFlag(flag);
    }
}
