package com.rf.kjb.scale.util;

import lombok.extern.slf4j.Slf4j;

import javax.persistence.AttributeConverter;
import javax.persistence.Converter;

/**
 * @author lpf
 * @description: 属性加密解密转换器, 从String到String进行转换（只做加密解密部分操作）
 * @date 2022/4/7 9:07
 */
@Converter
@Slf4j
public class EncryptDecodeConverter implements AttributeConverter<String, String> {

    /**
     * 入库操作，即对入库属性进行加密
     *
     * @param attribute
     * @return
     */
    @Override
    public String convertToDatabaseColumn(String attribute) {
        //return attribute;
        //log.info("原数据：" + attribute);
        return DESede.encryptString(attribute);
    }

    /**
     * 出库查询，即对数据库属性进行解密
     *
     * @param dbData
     * @return
     */
    @Override
    public String convertToEntityAttribute(String dbData) {
        //log.info("加密数据：" + dbData);
        return DESede.decryptString(dbData);
    }
}
