package com.rf.kjb.user.dao.model;

import com.rf.kjb.base.model.BaseEntry;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.DynamicUpdate;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;


/**
 * {@code @Author:zzf}
 * {@code @Date:2022/7/22:18:19}
 * {@code @Description:}
 */
@Data
@Entity
@AllArgsConstructor
@NoArgsConstructor
@Table(name = "t_user_info")
@org.hibernate.annotations.Table(appliesTo = "t_user_info", comment = "用户信息表")
@DynamicUpdate
public class UserEntry extends BaseEntry {

    @Column(name = "user_name",columnDefinition = "varchar(50) not null comment '用户名'")
    private String userName;
    @Column(name = "identifier" ,columnDefinition = "varchar(20) not null unique comment '编号'")
    private String identifier;
    @Column(name = "age",columnDefinition = "tinyint not null default 0 comment '年龄' ")
    private int age;
    @Column(name = "gender",columnDefinition = "tinyint not null default 1 comment '性别：1 男 0 女'")
    private int gender;
    @Column(name = "password",columnDefinition = "varchar(50) not null comment '密码'")
    private String password;
    @Column(name = "profession",columnDefinition = "varchar(20) comment '职业'")
    private String profession;
    @Column(name = "role",columnDefinition = "tinyint not null default 0 comment '角色：0普通用户 1管理员'")
    private int role;
    @Column(name = "marriage_situation",columnDefinition = "varchar(10）comment '已婚0 未婚 1 离异 2' ")
    private String marriageSituation;
}
