package com.rf.kjb.user.dao.repository;

import com.rf.kjb.base.repository.BaseRepository;
import com.rf.kjb.user.dao.model.UserEntry;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import javax.transaction.Transactional;
import java.util.List;

public interface UserRepository extends BaseRepository<UserEntry,String> {
    UserEntry findByIdentifier(String identifier);

    @Transactional
    @Modifying
    @Query(value="update t_user_info set password = :password where identifier = :identifier",nativeQuery = true)
    void updatePasswordByIdentifier(@Param("identifier") String identifier, @Param("password") String password);

    @Query(value = "select identifier from t_user_info where user_name like :userName",nativeQuery = true)
    List<String> findIdentifierByName(@Param("userName") String userName);

    UserEntry findByIdentifierAndPassword(String identifier, String password);

    void deleteByIdentifier(String identifier);
}
