package com.rf.kjb.user.service;

import com.rf.kjb.user.dao.model.UserEntry;
import org.springframework.data.domain.Page;

import java.util.List;

public interface UserService {
    /**
     * identifier ---> user
     * @param identifier
     * @return
     */
    UserEntry findByIdentifier(String identifier);

    /**
     * save
     * @param userEntry
     */
    void save(UserEntry userEntry);

    /**
     * reset password
     * @param identifier
     * @param defaultPassword
     */
    void resetPasswordByIdentifier(String identifier, String defaultPassword);

    /**
     * 分页查询
     * @param json
     * @return
     */
    Page<UserEntry> find(String json);

    /**
     * 用户名查询identifier
     * @param userName
     * @return
     */
    List<String> findIdentifierByName(String userName);

    List<UserEntry> findByIdentifiers(List<String> identifiers);

    UserEntry findByIdentifierAndPassword(String identifier, String password);

    void deleteByIdentifier(String identifier);
}
