package com.rf.kjb.utils;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.kjb.scale.dao.model.RecordPhyEntry;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Comparator;
import java.util.stream.Stream;

/**
 * @Author:zzf
 * @Date:2022/8/8:11:54
 * @Description:
 */
public class FileUtils {

    /**
     * 生理信号源数据txt文本 转换成 excel单列
     * txt文本格式   a,b,c,d,e
     *
     * @param sourceFile 生理信号源数据txt文本
     * @param flag
     */
    public static File txt2excel(File sourceFile, String destFileParent, String flag) throws IOException {

//        File destParent = new File(destFileParent);
        String destFileName = sourceFile.getName();
        String destFilePath = destFileParent+destFileName.replace(".txt",".xlsx");
        File destFile = new File(destFilePath);
        if(!destFile.exists()) {
            File path = new File(destFileParent);
            if(!path.exists()){
                path.mkdir();
                destFile.createNewFile();
            }
        }
        Workbook wb = new XSSFWorkbook();
        //设置sheet名称，并创建新的sheet对象
        String sheetName = "用户测试结果导出";
        Sheet downSheet = wb.createSheet(sheetName);
        //获取表头行 暂时不做表头
        //Row titleRow = downSheet.createRow(0);
        //创建单元格，设置style居中，字体，单元格大小等
        CellStyle style = wb.createCellStyle();
        //设置水平对齐的样式为居中对齐;
        style.setAlignment(HorizontalAlignment.CENTER);
        //设置垂直对齐的样式为居中对齐;
        style.setVerticalAlignment(VerticalAlignment.CENTER);
        //

        //读取源数据文件并写入excel文件
        FileInputStream fis = new FileInputStream(sourceFile);
        InputStreamReader inputStreamReader = new InputStreamReader(fis, StandardCharsets.UTF_8);
        BufferedReader br = new BufferedReader(inputStreamReader);
        //flag = 3 脑电 json格式
        if(flag.equals("3")){
            String str = IOUtils.toString(fis, StandardCharsets.UTF_8);
            JSONObject jsonObject = JSONObject.parseObject(str);
            JSONArray waveDataAll = jsonObject.getJSONArray("waveDataAll");
            JSONArray deltaData = jsonObject.getJSONArray("deltaData");
            JSONArray thetaData = jsonObject.getJSONArray("thetaData");
            JSONArray lowAlphaData = jsonObject.getJSONArray("lowAlphaData");
            JSONArray highAlphaData = jsonObject.getJSONArray("highAlphaData");
            JSONArray lowBetaData = jsonObject.getJSONArray("lowBetaData");
            JSONArray highBetaData = jsonObject.getJSONArray("highBetaData");
            JSONArray lowGammaData = jsonObject.getJSONArray("lowGammaData");
            JSONArray midGammaData = jsonObject.getJSONArray("midGammaData");
            JSONArray noiseData = jsonObject.getJSONArray("noiseData");
            JSONArray attentionData = jsonObject.getJSONArray("attentionData");
            JSONArray meditationData = jsonObject.getJSONArray("meditationData");
            JSONArray focusNao = jsonObject.getJSONArray("focusNao");
            //title
            String [] title = new String[]{"waveDataAll", "deltaData","thetaData","lowAlphaData","highAlphaData","lowBetaData","highBetaData","lowGammaData","midGammaData","noiseData","attentionData","meditationData","focusNao"};
            Row titleRow = downSheet.createRow(0);

            titleRow.setRowStyle(style);
            for (int i = 0; i < title.length; i++) {
                Cell cell = titleRow.createCell(i);
                cell.setCellValue(title[i]);
            }
            //填充数据
            for (int i = 0; i < waveDataAll.size(); i++) {
                Row row = downSheet.createRow(i+1);

                Cell cellWaveDataAll = row.createCell(0);
                if(waveDataAll.size()>i){
                    cellWaveDataAll.setCellValue(waveDataAll.getString(i));
                }

                Cell cellDeltaData = row.createCell(1);
                if(deltaData.size()>i){
                    cellDeltaData.setCellValue(deltaData.getString(i));
                }
                Cell cellThetaData = row.createCell(2);
                if(thetaData.size()>i){
                    cellThetaData.setCellValue(thetaData.getString(i));
                }
                Cell CellLowAlphaData = row.createCell(3);
                if(lowAlphaData.size()>i){
                    CellLowAlphaData.setCellValue(lowAlphaData.getString(i));
                }
                Cell cellHighAlphaData = row.createCell(4);
                if(highAlphaData.size()>i){
                    cellHighAlphaData.setCellValue(highAlphaData.getString(i));
                }
                Cell cellLowBetaData = row.createCell(5);
                if(lowBetaData.size()>i){
                    cellLowBetaData.setCellValue(lowBetaData.getString(i));
                }
                Cell cellHighBetaData = row.createCell(6);
                if(highBetaData.size()>i){
                    cellHighBetaData.setCellValue(highBetaData.getString(i));
                }
                Cell cellLowGammaData = row.createCell(7);
                if(lowGammaData.size()>i){
                    cellLowGammaData.setCellValue(lowGammaData.getString(i));
                }
                Cell cellMidGammaData = row.createCell(8);
                if(midGammaData.size()>i){
                    cellMidGammaData.setCellValue(midGammaData.getString(i));
                }
                Cell cellNoiseData = row.createCell(9);
                if(noiseData.size()>i){
                    cellNoiseData.setCellValue(noiseData.getString(i));
                }
                Cell cellAttentionData = row.createCell(10);
                if(attentionData.size()>i){
                    cellAttentionData.setCellValue(attentionData.getString(i));
                }
                Cell cellMeditationData = row.createCell(11);
                if(meditationData.size()>i){
                    cellMeditationData.setCellValue(meditationData.getString(i));
                }
                Cell cellFocusNao = row.createCell(12);
                if(focusNao.size()>i){
                    cellFocusNao.setCellValue(focusNao.getString(i));
                }
            }

        }else{
            String line;
            while((line = br.readLine()) != null){
                String[] split = line.split(",");
                if(split.length>0){
                    for (int i = 0; i < split.length; i++) {
                        Row row = downSheet.createRow(i);
                        row.setRowStyle(style);
                        Cell cell = row.createCell(0);
                        cell.setCellValue(split[i]);
                    }
                }
            }
        }

//        OutputStream fileOut = new FileOutputStream(foldDir + "/" + fileName);
        OutputStream fileOut = Files.newOutputStream(destFile.toPath());
        wb.write(fileOut);
        fileOut.close();
        br.close();

        return destFile;
    }
    public static  String downloadFile(File file , String filePath , String fileName, HttpServletResponse response) throws IOException {
        response.reset();
        response.setContentType("application/octet-stream");
        response.setCharacterEncoding("utf-8");
        response.setContentLength((int) file.length());
        response.setHeader("Content-Disposition", "attachment;filename=" + java.net.URLEncoder.encode(fileName, "UTF-8"));
        response.setHeader("filename",java.net.URLEncoder.encode(fileName, "UTF-8"));
        byte[] buffer = new byte[1024];
        FileInputStream fis = null;
        BufferedInputStream bis = null;
        try {
            fis = new FileInputStream(file);
            bis = new BufferedInputStream(fis);
            OutputStream os = response.getOutputStream();
            int i = bis.read(buffer);
            while (i != -1) {
                os.write(buffer, 0, i);
                i = bis.read(buffer);
            }

            return "下载成功";
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (bis != null) {
                try {
                    bis.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (fis != null) {
                try {
                    fis.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            //将复制后的整个文件夹删除
            if(StringUtils.isNotBlank(filePath)){
                Path path = Paths.get(filePath);
                try (Stream<Path> walk = Files.walk(path)) {
                    walk.sorted(Comparator.reverseOrder())
                            .forEach(FileUtils::deleteDirectoryStream);
                }
            }
            //删除生成的压缩包
            if(file.exists()) file.delete();
        }
        return "下载失败";
    }

    public static void deleteDirectoryStream(Path path) {
        try {
            Files.delete(path);
            //System.out.printf("删除文件成功：%s%n",path.toString());
        } catch (IOException e) {
            //System.err.printf("无法删除的路径 %s%n%s", path, e);
        }
    }

    public static File txt2excel(File sourceFile, String destFileParent, String flag, RecordPhyEntry item) throws IOException {

//        File destParent = new File(destFileParent);
        String destFileName = sourceFile.getName();
        String destFilePath = destFileParent+destFileName.replace(".txt",".xlsx");
        File destFile = new File(destFilePath);
        if(!destFile.exists()) {
            File path = new File(destFileParent);
            if(!path.exists()){
                path.mkdir();
                destFile.createNewFile();
            }
        }
        Workbook wb = new XSSFWorkbook();
        //创建单元格，设置style居中，字体，单元格大小等
        CellStyle style = wb.createCellStyle();
        //设置水平对齐的样式为居中对齐;
        style.setAlignment(HorizontalAlignment.CENTER);
        //设置垂直对齐的样式为居中对齐;
        style.setVerticalAlignment(VerticalAlignment.CENTER);
        //
        if(flag.equals("1")){
            //指标
            String sheetNameTarget = "时域指标和频域指标";
            Sheet targetSheet = wb.createSheet(sheetNameTarget);
            JSONObject jsonObject = JSONObject.parseObject(item.getTestResult());
            if(jsonObject.keySet().size() >0 ){
                Row titleRow = targetSheet.createRow(0);
                Row targetRow = targetSheet.createRow(1);
                Object[] keys =  jsonObject.keySet().toArray();
                titleRow.setRowStyle(style);
                for (int i = 0; i < jsonObject.keySet().size(); i++) {
                    Cell cell = titleRow.createCell(i);
                    String titleValue = (String)keys[i];
                    if(titleValue.equalsIgnoreCase("lf_nu")){
                        titleValue = "LF_norm";
                    } else if (titleValue.equalsIgnoreCase("hf_nu")) {
                        titleValue = "HF_norm";
                    }
                    cell.setCellValue(titleValue);
                    Cell cellTarget = targetRow.createCell(i);
                    String value = jsonObject.getString((String) keys[i]);
                    if (!value.equals("-") && !value.equals("NaN")){
                        double v = Double.parseDouble(value);
                        BigDecimal b = new BigDecimal(v);
                        value = String.valueOf(b.setScale(2, RoundingMode.HALF_UP).doubleValue());
                    }
                    cellTarget.setCellValue(value);
                }
            }
        }
        //设置sheet名称，并创建新的sheet对象
        String sheetName = "原始数据";
        Sheet downSheet = wb.createSheet(sheetName);
        //获取表头行 暂时不做表头
        //Row titleRow = downSheet.createRow(0);

        //读取源数据文件并写入excel文件
        FileInputStream fis = new FileInputStream(sourceFile);
        InputStreamReader inputStreamReader = new InputStreamReader(fis, StandardCharsets.UTF_8);
        BufferedReader br = new BufferedReader(inputStreamReader);
        //flag = 3 脑电 json格式
        if(flag.equals("3")){
            String str = IOUtils.toString(fis, StandardCharsets.UTF_8);
            JSONObject jsonObject = JSONObject.parseObject(str);
            JSONArray waveDataAll = jsonObject.getJSONArray("waveDataAll");
            JSONArray deltaData = jsonObject.getJSONArray("deltaData");
            JSONArray thetaData = jsonObject.getJSONArray("thetaData");
            JSONArray lowAlphaData = jsonObject.getJSONArray("lowAlphaData");
            JSONArray highAlphaData = jsonObject.getJSONArray("highAlphaData");
            JSONArray lowBetaData = jsonObject.getJSONArray("lowBetaData");
            JSONArray highBetaData = jsonObject.getJSONArray("highBetaData");
            JSONArray lowGammaData = jsonObject.getJSONArray("lowGammaData");
            JSONArray midGammaData = jsonObject.getJSONArray("midGammaData");
            JSONArray noiseData = jsonObject.getJSONArray("noiseData");
            JSONArray attentionData = jsonObject.getJSONArray("attentionData");
            JSONArray meditationData = jsonObject.getJSONArray("meditationData");
            JSONArray focusNao = jsonObject.getJSONArray("focusNao");
            //title
            String [] title = new String[]{"waveDataAll", "deltaData","thetaData","lowAlphaData","highAlphaData","lowBetaData","highBetaData","lowGammaData","midGammaData","noiseData","attentionData","meditationData","focusNao","alpha","beta","脑力疲劳程度"};
            Row titleRow = downSheet.createRow(0);

            titleRow.setRowStyle(style);
            for (int i = 0; i < title.length; i++) {
                Cell cell = titleRow.createCell(i);
                cell.setCellValue(title[i]);
            }
            //填充数据
            for (int i = 0; i < waveDataAll.size(); i++) {
                Row row = downSheet.createRow(i+1);
                Cell cellWaveDataAll = row.createCell(0);
                if(waveDataAll.size()>i){
                    cellWaveDataAll.setCellValue(waveDataAll.getString(i));
                }
                Cell cellDeltaData = row.createCell(1);
                if(deltaData.size()>i){
                    cellDeltaData.setCellValue(deltaData.getString(i));
                }
                Cell cellThetaData = row.createCell(2);
                if(thetaData.size()>i){
                    cellThetaData.setCellValue(thetaData.getString(i));
                }
                Cell CellLowAlphaData = row.createCell(3);
                if(lowAlphaData.size()>i){
                    CellLowAlphaData.setCellValue(lowAlphaData.getString(i));
                }
                Cell cellHighAlphaData = row.createCell(4);
                if(highAlphaData.size()>i){
                    cellHighAlphaData.setCellValue(highAlphaData.getString(i));
                }
                Cell cellLowBetaData = row.createCell(5);
                if(lowBetaData.size()>i){
                    cellLowBetaData.setCellValue(lowBetaData.getString(i));
                }
                Cell cellHighBetaData = row.createCell(6);
                if(highBetaData.size()>i){
                    cellHighBetaData.setCellValue(highBetaData.getString(i));
                }
                Cell cellLowGammaData = row.createCell(7);
                if(lowGammaData.size()>i){
                    cellLowGammaData.setCellValue(lowGammaData.getString(i));
                }
                Cell cellMidGammaData = row.createCell(8);
                if(midGammaData.size()>i){
                    cellMidGammaData.setCellValue(midGammaData.getString(i));
                }
                Cell cellNoiseData = row.createCell(9);
                if(noiseData.size()>i){
                    cellNoiseData.setCellValue(noiseData.getString(i));
                }
                Cell cellAttentionData = row.createCell(10);
                if(attentionData.size()>i){
                    cellAttentionData.setCellValue(attentionData.getString(i));
                }
                Cell cellMeditationData = row.createCell(11);
                if(meditationData.size()>i){
                    cellMeditationData.setCellValue(meditationData.getString(i));
                }
                Cell cellFocusNao = row.createCell(12);
                if(focusNao.size()>i){
                    cellFocusNao.setCellValue(focusNao.getString(i));
                }
                Cell cellAlpha = row.createCell(13);
                cellAlpha.setCellValue("");
                int alphaData = 0 ;
                int lowAlpha = 0;
                int highAlpha = 0;
                if(lowAlphaData.size()>i ){
                    lowAlpha = lowAlphaData.getIntValue(i);
                }
                if(highAlphaData.size()>i){
                    highAlpha = highAlphaData.getIntValue(i);
                    cellAlpha.setCellValue(alphaData);
                }
                alphaData =lowAlpha+highAlpha;
                cellAlpha.setCellValue(alphaData == 0?"":String.valueOf(alphaData));

                int betaData;
                int lowBeta = 0;
                int highBeta = 0 ;
                if(lowBetaData.size()>i ){
                    lowBeta = lowBetaData.getIntValue(i);
                }
                if(highBetaData.size()>i){
                    highBeta = highBetaData.getIntValue(i);
                }
                Cell cellBeta = row.createCell(14);
                cellBeta.setCellValue("");
                betaData = lowBeta+highBeta;
                cellBeta.setCellValue(betaData);
                cellBeta.setCellValue(betaData == 0?"":String.valueOf(betaData));
                Cell cellHead = row.createCell(15);
                cellHead.setCellValue("");
                if(betaData > 0){
                    double v = (alphaData + thetaData.getDoubleValue(i)) / betaData;
                    BigDecimal bigDecimal = new BigDecimal(v);
                    cellHead.setCellValue(bigDecimal.setScale(2,RoundingMode.HALF_UP).doubleValue());
                }
            }
        }else{
            String line;
            while((line = br.readLine()) != null){
                String[] split = line.split(",");
                if(split.length>0){
                    for (int i = 0; i < split.length; i++) {
                        Row row = downSheet.createRow(i);
                        row.setRowStyle(style);
                        Cell cell = row.createCell(0);
                        cell.setCellValue(split[i]);
                    }
                }
            }
        }

//        OutputStream fileOut = new FileOutputStream(foldDir + "/" + fileName);
        OutputStream fileOut = Files.newOutputStream(destFile.toPath());
        wb.write(fileOut);
        fileOut.close();
        br.close();

        return destFile;
    }
}
