package com.rf.kjb.utils;

import com.auth0.jwt.JWT;
import com.auth0.jwt.JWTCreator;
import com.auth0.jwt.algorithms.Algorithm;
import com.auth0.jwt.exceptions.TokenExpiredException;
import com.auth0.jwt.interfaces.DecodedJWT;
import com.rf.kjb.user.dao.model.UserEntry;

import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author:zzf
 * @Date:2022/7/25:08:31
 * @Description:
 */
public class JWTUtil {

    //密钥签名
    private static final String SING = "xVWGEYTPF1hjnFt$HDZ0f^iet^^q@hZv";

    /**
     * 生成Token header.payload.sing
     */
    public static String getToken(Map<String, String> map) {

        Calendar instance = Calendar.getInstance();
        //5天后过期
        instance.add(Calendar.DATE, 5);
        //创建jwtBuilder
        JWTCreator.Builder builder = JWT.create();
        //将参数放进去
        map.forEach(builder::withClaim);
        String token = builder.withExpiresAt(instance.getTime())//指定过期时间
                .sign(Algorithm.HMAC256(SING));//添加签名
        return token;
    }

    public static String getTokenByUserInfo(UserEntry userEntry){
        HashMap<String, String> payload = new HashMap<>();
        payload.put("userName", userEntry.getUserName());
        payload.put("id", userEntry.getId());
        payload.put("identifier", userEntry.getIdentifier());
        payload.put("profession", userEntry.getProfession());
        payload.put("age", String.valueOf(userEntry.getAge()));
        payload.put("gender", String.valueOf(userEntry.getGender()));
        return  getToken(payload);
    }

    /**
     * 验证token,并获取信息
     */
    public static DecodedJWT verify(String token) {
        DecodedJWT verify;
        try {
            verify = JWT.require(Algorithm.HMAC256(SING)).build().verify(token);
        } catch (TokenExpiredException e) {
            throw new TokenExpiredException("token过期");
        }
        return verify;
    }


}
